HDU 5113 Black And White(DFS+剪枝)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5113

题面:

Black And White

Time Limit: 2000/2000 MS (Java/Others)    Memory Limit: 512000/512000 K (Java/Others)

Total Submission(s): 1336    Accepted Submission(s): 350

Special Judge

Problem Description

In mathematics, the four color theorem, or the four color map theorem, states that, given any separation of a plane into contiguous regions, producing a figure called a map, no more than four colors are required to color the regions
of the map so that no two adjacent regions have the same color.

— Wikipedia, the free encyclopedia

In this problem, you have to solve the 4-color problem. Hey, I’m just joking.

You are asked to solve a similar problem:

Color an N × M chessboard with K colors numbered from 1 to K such that no two adjacent cells have the same color (two cells are adjacent if they share an edge). The i-th color should be used in exactly ci cells.

Matt hopes you can tell him a possible coloring.

Input

The first line contains only one integer T (1 ≤ T ≤ 5000), which indicates the number of test cases.

For each test case, the first line contains three integers: N, M, K (0 < N, M ≤ 5, 0 < K ≤ N × M ).

The second line contains K integers ci (ci > 0), denoting the number of cells where the i-th color should be used.

It’s guaranteed that c1 + c2 + · · · + cK = N × M .

Output

For each test case, the first line contains “Case #x:”, where x is the case number (starting from 1).

In the second line, output “NO” if there is no coloring satisfying the requirements. Otherwise, output “YES” in one line. Each of the following N lines contains M numbers seperated by single whitespace, denoting the color of the cells.

If there are multiple solutions, output any of them.

Sample Input

4
1 5 2
4 1
3 3 4
1 2 2 4
2 3 3
2 2 2
3 2 3
2 2 2

Sample Output

Case #1:
NO
Case #2:
YES
4 3 4
2 1 2
4 3 4
Case #3:
YES
1 2 3
2 3 1
Case #4:
YES
1 2
2 3
3 1

Source

2014ACM/ICPC亚洲区北京站

解题:

因为n,m比较小,会想到搜索,但直接超时了。需要加一个剪枝,因为当剩下的容量为n时,任意一种颜色最多只能为(n+1)/2。当任意一种颜色数量超过这个值时,就返回。这个优化已经很厉害了。我又加了一个没什么用的优化,main函数中出现某两种颜色相同时,不用重复计算。

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <queue>
#include <cmath>
#include <cstdlib>
#include <set>
#include <algorithm>
#include <string>
#include <iomanip>
#define LL long long
using namespace std;
int map [7][7],color[30];
int n,m,t,k,sz,amount,tmp;
bool flag=false;
void init()
{
	for(int i=0;i<7;i++)
		map[0][i]=-1;
	for(int j=1;j<7;j++)
		map[j][0]=-1;
}
void dfs(int x,int y,int typ,int lef)
{
  tmp=(lef+1)/2;
  for(int i=1;i<=k;i++)
  {
	  if(color[i]>tmp)
	  return;
  }
  if(flag)return;
  if(color[typ]==0)return;
  if(map[x-1][y]!=typ&&map[x][y-1]!=typ)
  {
	  map[x][y]=typ;
	  color[typ]--;
	  if(x==n&&y==m)
	  {
		  flag=true;
		  return;
	  }
	  else if(y==m)
	  {
		  tmp=0;
		  for(int i=1;i<=k;i++)
		  {
			  if(color[i])tmp++;
		  }
		  if(tmp==1)
		  {
			  if(m!=1)
			  {
				  color[typ]++;
				  return;
			  }
		  }
		  for(int i=1;i<=k;i++)
		  {
			  if(color[i])
				  dfs(x+1,1,i,lef-1);
		  }
	  }
	  else
	  {
		  for(int i=1;i<=k;i++)
		  {
			  if(color[i])
			  {
				  dfs(x,y+1,i,lef-1);
			  }
		  }
	  }
	  color[typ]++;
  }
  return;
}
int main()
{
	init();
	scanf("%d",&t);
	for(int i=1;i<=t;i++)
	{
	  set <int> cnt;
	  printf("Case #%d:\n",i);
      scanf("%d%d%d",&n,&m,&k);
	  amount=(n*m+1)/2;
	  flag=true;
	  if(k==1)
	  {
		  if(n*m!=1)
		  flag=false;
	  }
	  for(int j=1;j<=k;j++)
	  {
		  scanf("%d",&color[j]);
          if(color[j]>amount)
			  flag=false;
	  }
	  if(flag)
	  {
	    flag=false;
	    for(int j=1;j<=k;j++)
	    {
		  sz=cnt.size();
		  if(color[j])
		  {
			  cnt.insert(color[j]);
			  if(cnt.size()>sz)
			  dfs(1,1,j,n*m);
		  }
	    }
	   }
	  if(flag)
	  {
		  printf("YES\n");
		  for(int j=1;j<=n;j++)
		  {
            printf("%d",map[j][1]);
			for(int k=2;k<=m;k++)
				printf(" %d",map[j][k]);
			printf("\n");
		  }
	  }
	  else
	  {
		  printf("NO\n");
	  }
	}
	return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-12 03:37:25

HDU 5113 Black And White(DFS+剪枝)的相关文章

[HDU 5113] Black And White (dfs+剪枝)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5113 题目大意:给你N*M的棋盘,K种颜色,每种颜色有c[i]个(sigma(c[i]) = N*M),现在给棋盘染色,使得相邻的两个棋盘染成不同的颜色,并且把所有颜色用完. 因为棋盘最大为5*5的,因此可以考虑搜索+剪枝. 从左到右,从上到下看当前格子能够染成什么颜色. 有一个限制性条件,就是说如果当前棋盘的格子数量的一半小于一种颜色的数量时,那么就一定有两个相邻的棋盘被染成了相同的颜色. 因为假

HDOJ 5113 Black And White DFS+剪枝

DFS+剪枝... 在每次DFS前,当前棋盘的格子数量的一半小于一种颜色的数量时就剪掉 Black And White Time Limit: 2000/2000 MS (Java/Others)    Memory Limit: 512000/512000 K (Java/Others) Total Submission(s): 194    Accepted Submission(s): 50 Special Judge Problem Description In mathematics,

HDU 5113 Black And White (dfs)

题目链接: 传送门 题意: 给定你一个n*m的格子,然后k种颜色给这个图涂色,要求 相邻的两个格子的颜色不相同(四个方向),而且第i种颜 色恰好出现c[i]次,问能否给这个图涂色成功. 分析: 首先我们考虑一种情况,n*m的格子用一种颜色给他涂色,保 证相邻的格子的颜色不同那么最多可以涂(m*n+1)/2 ,那么 我们搜索的时候可以直接根据这个条件来剪枝了.然后从下 到上一层一层的进行涂色. 代码如下: #include <iostream> #include <cstdio> #

hdu5113 Black And White(dfs+剪枝)

题目链接:点击打开链接 题意描述:给一个n*m的棋盘,现在有k种颜色的涂料,每种涂料可以使用ai次.求能否找出一种方案,给所有的格子染色,保证相邻的格子之间颜色不同.如果存在给出任意一种解决方案:否则输出NO 解题思路:dfs+剪枝 由于题目中棋盘最大为5×5所以可以考虑使用dfs,染色问题有一个结论貌似是:(剩余的格子的数量+1)>= 任意一种涂料的个数,否则染色必然失败.因此我们可以通过这个性质进行剪枝,此题如果不剪枝会TLE 代码: #include <cstdio> #inclu

hdu 5113 Black And White (dfs回溯+剪枝)

Black And White Time Limit: 2000/2000 MS (Java/Others)    Memory Limit: 512000/512000 K (Java/Others) Total Submission(s): 854    Accepted Submission(s): 218 Special Judge Problem Description In mathematics, the four color theorem, or the four color

搜索(剪枝优化):HDU 5113 Black And White

Description In mathematics, the four color theorem, or the four color map theorem, states that, given any separation of a plane into contiguous regions, producing a figure called a map, no more than four colors are required to color the regions of th

HDU 5113 Black And White(暴力dfs+减枝)

题目大意:给你一个n×m的矩阵,然后给你k种颜色,每种颜色有x种,所有的个数加起来恰好为n×m个.问你让你对这个矩阵进行染色问你,能不能把所有的小方格都染色,而且相邻两个颜色不同. 思路:一开始想的是构造,先按照个数进行排序,枚举每一个位置,贪心的策略先放多的,如果可以全部放下就输出YES,以及存贮的方案,否则输出NO,但是有bug,一直不对... 正解:dfs暴力枚举每一个点,裸的话需要25!,显然会超时,需要先排个序用构造的策略,让多的先放这样可以减枝.然后再dfs就可以了. Black A

HDU 5113 Black And White ( 2014 北京区预赛 B 、搜索 + 剪枝 )

题目链接 题意 : 给出 n * m 的网格.要你用 k 种不同的颜色填给出的网格.使得相邻的格子颜色不同.若有解要输出具体的方案 分析 : 看似构造.实则搜索.手构构半天没有什么好想法 直接搜就行了.注意加上剪枝 当剩下格子不足以让剩下颜色数量最多的颜色产生间隔的话则返回 具体也很好实现.即 max( 剩下的最多数量的那种颜色的数量 ) > ( 还剩多少格子 + 1 ) / 2 #include<bits/stdc++.h> using namespace std; const int

hdu 5113 Black And White

http://acm.hdu.edu.cn/showproblem.php?pid=5113 题意:给你n*m的格子,然后在每个格子内涂色,相邻格子不能同色,然后给你每个颜色涂的格子的固定个数,然后可不可以实现,可以实现输出任意一种,否则输出NO 思路:dfs枚举,剪纸,每种颜色剩余的个数不能超过剩余格子数的一半,如果剩余格子数是奇数,不能超过一半加1,偶数是一半. 1 #include <cstdio> 2 #include <cstring> 3 #include <al